import unittest
import sys
from aoc.sys import devicemgr, datastore
from mock import Mock

sys.path.insert(0, "../../python")
from l3vpn.l3vpn import L3VPNService


class Test(unittest.TestCase):
    xml = '''
  <l3vpn xmlns="http://example.com/l3vpn">
    <deviceName>NE8000</deviceName>
    <vrfName>4G_test</vrfName>
    <rd>100:1</rd>
    <rt>100:11</rt>
    <ifName>GigabitEthernet0/5/0.1</ifName>
    <description>wireless base</description>            
    <ip>20.1.2.9</ip>
    <subnet>255.255.255.0</subnet>    
    <peerAddress>2.2.2.2</peerAddress>
  </l3vpn>
    '''

    def mock_get_id(self, neName):
        if neName == 'NE8000':
            return 'mock_neid:NE8000'
        return 'mock_neid:NE8000'

    def mock_sys_func(self):
        devicemgr.query_neid = self.mock_get_id

        # Ethernet0/1/3.101   GigabitEthernet0/5/4.101
        mock_read_datastore_rdb = Mock(return_value='GigabitEthernet0/5/0')
        datastore.read_datastore_rdb = mock_read_datastore_rdb

        mock_write_datastore = Mock(return_value='success')
        datastore.write_datastore = mock_write_datastore

        devicemgr.is_snd = self.mock_is_snd

    def mock_is_snd(self, nename, sndid):
        if nename == 'mock_neid:NE8000' and sndid == 'NE8000M8_SND':
            return True
        if nename == 'mock_neid:NE8000' and sndid == 'NE8000M8SPC300_SND':
            return True
        return False

    def setUp(self):
        self.mock_sys_func()

    def test_l3vpn(self):
        result = L3VPNService().ncs_map_test(self.xml)
        print(result)


if __name__ == "__main__":
    unittest.main()
